.origin 0
.entrypoint START

#include "stddef.hp"
#define P8_11 r30.t15
#define P8_12 r30.t14
#define P8_15 r31.t15
#define P8_16 r31.t14

// counter: 
#define counter r1
#define length  r2
#define last    r3
#define temp    r4
#define output  r30
#define input   r31

IIC:
	// Activeer de I2C-bus
	LBCO r0, CONST_PRUCFG, 4, 4
	CLR  r0, r0, 4
	SBCO r0, CONST_PRUCFG, 4, 4

START:
	ZERO &r0, 4*11 // Leeg registers 0 t/m 10
	ZERO &output, 4
	MOV  last, input
	
	// Zet een 0 in de array
	ADD  length, length, 1
	LSL  temp, length, 2
	SBCO r0, CONST_PRUDRAM, temp, 4
	SBCO length, CONST_PRUDRAM, 0, 4
	
	
REPEAT:
	XOR  temp, input, last //5 ns
	MOV  last, input       //10 ns
	QBBS CHANGED, temp.t15 //15 ns
	UNCHANGED:
		ADD  counter, counter, 25 //20 ns
		QBA  REPEAT               //25 ns
	CHANGED:
		ADD  length, length, 1               //20 ns
		LSL  temp, length, 2                 //25 ns
		QBBS HIGH, P8_15                     //30 ns
		LOW:                                 //35 ns
			QBA  ENDIF
		HIGH:
			SET  counter.t30
		ENDIF:
		SBCO counter, CONST_PRUDRAM, temp, 4 //45 ns
		SBCO length, CONST_PRUDRAM, 0, 4     //55 ns
		LDI  counter, 65                     //60 ns
		QBA  REPEAT                          //65 ns
